;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8L
;Program type        : Application
;Clock frequency     : 8.000000 MHz
;Memory model        : Small
;Optimize for        : Speed
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 256 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "linefollower1.vec"
	.INCLUDE "linefollower1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x160
;       1 //This program is geneerated by M.Mashaghi
;       2 //e-mail:m.mashaghi@gmail.com
;       3 //Date    : 2006/08/15
;       4 #include<mega8.h>
;       5 #include<delay.h> 
;       6 #include<math.h>
;       7 #define kp 2 
;       8 #define kd 0
;       9 #define ki 0
;      10 #define speed 100
;      11 #define ADC_CONFIGURATION 0b00100000  // Read the 8 most significant bits of the AD conversion result
;      12 void calibration();
;      13 void readlineposition();
;      14 void PID();
;      15 void PWM();
;      16 void end_of_following();
;      17 unsigned char read_adc(unsigned char adc_input)
;      18 {

	.CSEG
_read_adc:
;      19 ADMUX=adc_input|ADC_CONFIGURATION;
	LD   R30,Y
	ORI  R30,0x20
	OUT  0x7,R30
;      20 ADCSRA|=0x40;// Start the AD conversion
	SBI  0x6,6
;      21 while ((ADCSRA & 0x10)==0);// Wait for the AD conversion to complete
_0x30:
	SBIS 0x6,4
	RJMP _0x30
;      22 ADCSRA|=0x10; 
	SBI  0x6,4
;      23 return ADCH;
	IN   R30,0x5
	ADIW R28,1
	RET
;      24 }
;      25 char e,P,D,I;
;      26 int u;
;      27 unsigned char i,m,n; 
;      28 unsigned char sensor_white[6],sensor_black[6],sensor_state[6],zero[6],x[2,2];

	.DSEG
_sensor_white:
	.BYTE 0x6
_sensor_black:
	.BYTE 0x6
_sensor_state:
	.BYTE 0x6
_zero:
	.BYTE 0x6
_x:
	.BYTE 0x4
;      29 float span[6];
_span:
	.BYTE 0x18
;      30 
;      31 main()
;      32 {

	.CSEG
_main:
;      33  DDRB=0xdf;
	LDI  R30,LOW(223)
	OUT  0x17,R30
;      34  PORTB=0;
	CLR  R30
	OUT  0x18,R30
;      35  DDRC=0;
	OUT  0x14,R30
;      36  PORTC=0;
	OUT  0x15,R30
;      37  DDRD=0xff;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;      38  PORTD=0;
	CLR  R30
	OUT  0x12,R30
;      39  I=0;P=0;D=0; 
	CLR  R7
	CLR  R5
	CLR  R6
;      40  // Timer/Counter 1 initialization
;      41  // Clock source: System Clock
;      42  // Clock value: 125.000 kHz
;      43  // Mode: Normal top=FFFFh
;      44  // OC1A output: Clear
;      45  // OC1B output: Clear
;      46  // Noise Canceler: Off
;      47  // Input Capture on Falling Edge
;      48  TCCR1A=0xA1;
	LDI  R30,LOW(161)
	OUT  0x2F,R30
;      49  TCCR1B=0x01;
	LDI  R30,LOW(1)
	OUT  0x2E,R30
;      50  TCNT1H=0;TCNT1L=0;
	CLR  R30
	OUT  0x2D,R30
	OUT  0x2C,R30
;      51  OCR1AH=0;OCR1AL=0;
	OUT  0x2B,R30
	OUT  0x2A,R30
;      52  OCR1BH=0;OCR1BL=0;
	OUT  0x29,R30
	OUT  0x28,R30
;      53  // ADC initialization
;      54  //ADC Clock frequency: 500.000 kHz
;      55  // ADC Voltage Reference: AREF
;      56  // ADC High Speed Mode: Off
;      57  //ADC Auto Trigger Source: None
;      58  ADMUX=ADC_CONFIGURATION;
	LDI  R30,LOW(32)
	OUT  0x7,R30
;      59  ADCSRA=0x80;
	LDI  R30,LOW(128)
	OUT  0x6,R30
;      60  SFIOR&=0xEF;
	IN   R30,0x30
	ANDI R30,0xEF
	OUT  0x30,R30
;      61  ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;      62 
;      63  calibration();
	RCALL _calibration
;      64  while(1)
_0x34:
;      65  {
;      66     readlineposition();
	RCALL _readlineposition
;      67     PID();
	RCALL _PID
;      68     PWM();
	RCALL _PWM
;      69     if(~PINB.5) end_of_following();
	SBIS 0x16,5
	RCALL _end_of_following
;      70  } 
	RJMP _0x34
;      71 }
_0x38:
	RJMP _0x38
;      72 
;      73 //----------------------------CALIBRATION----------------------------------
;      74 void calibration()
;      75 {  
_calibration:
;      76     while (PINB.5)
_0x3A:
	SBIS 0x16,5
	RJMP _0x3C
;      77     {
;      78        PORTB.4=1;
	SBI  0x18,4
;      79        delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      80        PORTB.4=0;
	CBI  0x18,4
;      81        delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      82     }
	RJMP _0x3A
_0x3C:
;      83     PORTB.4=0;
	CBI  0x18,4
;      84     while (PINB.5==0);
_0x3D:
	SBIS 0x16,5
	RJMP _0x3D
;      85     delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      86  
;      87     for (i=0;i<=5;i++)    
	CLR  R10
_0x41:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRLO _0x42
;      88     {
;      89        PORTD=ceil(pow(2,i));
	__GETD1N 0x40000000
	RCALL __PUTPARD1
	MOV  R30,R10
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __PUTPARD1
	RCALL _pow
	RCALL __PUTPARD1
	RCALL _ceil
	RCALL __CFD1
	OUT  0x12,R30
;      90        delay_us(50);
	__DELAY_USB 133
;      91        m=read_adc(i); 
	ST   -Y,R10
	RCALL _read_adc
	MOV  R11,R30
;      92        PORTD=0;
	CLR  R30
	OUT  0x12,R30
;      93        delay_us(50);
	__DELAY_USB 133
;      94        n=read_adc(i); 
	ST   -Y,R10
	RCALL _read_adc
	MOV  R12,R30
;      95        sensor_white[i]=m-n;
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_white)
	SBCI R31,HIGH(-_sensor_white)
	PUSH R31
	PUSH R30
	MOV  R30,R11
	SUB  R30,R12
	POP  R26
	POP  R27
	ST   X,R30
;      96     }
	INC  R10
	RJMP _0x41
_0x42:
;      97     
;      98     while (PINB.5)
_0x43:
	SBIS 0x16,5
	RJMP _0x45
;      99     {
;     100        PORTB.4=1;
	SBI  0x18,4
;     101        delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     102        PORTB.4=0;
	CBI  0x18,4
;     103        delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     104     }
	RJMP _0x43
_0x45:
;     105     PORTB.4=0;
	CBI  0x18,4
;     106     while (PINB.5==0);
_0x46:
	SBIS 0x16,5
	RJMP _0x46
;     107     delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     108 
;     109     for (i=0;i<=5;i++)    
	CLR  R10
_0x4A:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRLO _0x4B
;     110     {
;     111        PORTD=ceil(pow(2,i));
	__GETD1N 0x40000000
	RCALL __PUTPARD1
	MOV  R30,R10
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __PUTPARD1
	RCALL _pow
	RCALL __PUTPARD1
	RCALL _ceil
	RCALL __CFD1
	OUT  0x12,R30
;     112        delay_us(50);
	__DELAY_USB 133
;     113        m=read_adc(i); 
	ST   -Y,R10
	RCALL _read_adc
	MOV  R11,R30
;     114        PORTD=0;
	CLR  R30
	OUT  0x12,R30
;     115        delay_us(50);
	__DELAY_USB 133
;     116        n=read_adc(i); 
	ST   -Y,R10
	RCALL _read_adc
	MOV  R12,R30
;     117        sensor_black[i]=m-n;
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_black)
	SBCI R31,HIGH(-_sensor_black)
	PUSH R31
	PUSH R30
	MOV  R30,R11
	SUB  R30,R12
	POP  R26
	POP  R27
	ST   X,R30
;     118     } 
	INC  R10
	RJMP _0x4A
_0x4B:
;     119     //calculating ZERO and SPAN coeffecients.
;     120     //these coeffecients assumed to calibrate each sensor.
;     121     for (i=0;i<=5;i++)    
	CLR  R10
_0x4D:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRLO _0x4E
;     122        span[i]=150/(sensor_white[i]-sensor_black[i]);
	MOV  R30,R10
	LDI  R26,LOW(_span)
	LDI  R27,HIGH(_span)
	CLR  R31
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_white)
	SBCI R31,HIGH(-_sensor_white)
	LD   R30,Z
	PUSH R30
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_black)
	SBCI R31,HIGH(-_sensor_black)
	LD   R30,Z
	POP  R26
	RCALL __SWAPB12
	SUB  R30,R26
	LDI  R26,LOW(150)
	RCALL __DIVB21U
	POP  R26
	POP  R27
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __PUTDP1
	INC  R10
	RJMP _0x4D
_0x4E:
;     123     for (i=0;i<=5;i++)    
	CLR  R10
_0x50:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRSH PC+2
	RJMP _0x51
;     124        zero[i]=200-((sensor_white[i]*span[i])/(sensor_white[i]-sensor_black[i]));
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_zero)
	SBCI R31,HIGH(-_zero)
	PUSH R31
	PUSH R30
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_white)
	SBCI R31,HIGH(-_sensor_white)
	LD   R30,Z
	PUSH R30
	MOV  R30,R10
	LDI  R26,LOW(_span)
	LDI  R27,HIGH(_span)
	CLR  R31
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETD1P
	POP  R26
	CLR  R27
	CLR  R24
	CLR  R25
	RCALL __CDF2
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_white)
	SBCI R31,HIGH(-_sensor_white)
	LD   R30,Z
	PUSH R30
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_black)
	SBCI R31,HIGH(-_sensor_black)
	LD   R30,Z
	POP  R26
	RCALL __SWAPB12
	SUB  R30,R26
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __DIVF21
	__GETD2N 0x43480000
	RCALL __SWAPD12
	RCALL __SUBF12
	POP  R26
	POP  R27
	RCALL __CFD1
	ST   X,R30
	INC  R10
	RJMP _0x50
_0x51:
;     125     
;     126     while (PINB.5)
_0x52:
	SBIS 0x16,5
	RJMP _0x54
;     127     {
;     128        PORTB.4=1;delay_ms(50);
	SBI  0x18,4
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     129        PORTB.4=0;delay_ms(50);
	CBI  0x18,4
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     130     }
	RJMP _0x52
_0x54:
;     131     PORTB.4=0;
	CBI  0x18,4
;     132     while (PINB.5==0);
_0x55:
	SBIS 0x16,5
	RJMP _0x55
;     133     delay_ms(1000); 
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     134 }
	RET
;     135 //------------------------READ CURRENT LINE POSITION------------------------
;     136 void readlineposition()
;     137 {
_readlineposition:
;     138     for (i=0;i<=5;i++)
	CLR  R10
_0x5A:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRLO _0x5B
;     139     {
;     140        PORTD=ceil(pow(2,i));
	__GETD1N 0x40000000
	RCALL __PUTPARD1
	MOV  R30,R10
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __PUTPARD1
	RCALL _pow
	RCALL __PUTPARD1
	RCALL _ceil
	RCALL __CFD1
	OUT  0x12,R30
;     141        delay_us(50);
	__DELAY_USB 133
;     142        m=read_adc(i); 
	ST   -Y,R10
	RCALL _read_adc
	MOV  R11,R30
;     143        PORTD=0;
	CLR  R30
	OUT  0x12,R30
;     144        delay_us(50);
	__DELAY_USB 133
;     145        n=read_adc(i); 
	ST   -Y,R10
	RCALL _read_adc
	MOV  R12,R30
;     146        sensor_state[i]=m-n;
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_state)
	SBCI R31,HIGH(-_sensor_state)
	PUSH R31
	PUSH R30
	MOV  R30,R11
	SUB  R30,R12
	POP  R26
	POP  R27
	ST   X,R30
;     147        //sensor_state[i]=m;
;     148     }
	INC  R10
	RJMP _0x5A
_0x5B:
;     149     for (i=0;i<=5;i++)   sensor_state[i]=(sensor_state[i]*span[i])+zero[i];
	CLR  R10
_0x5D:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRLO _0x5E
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_state)
	SBCI R31,HIGH(-_sensor_state)
	PUSH R31
	PUSH R30
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_state)
	SBCI R31,HIGH(-_sensor_state)
	LD   R30,Z
	PUSH R30
	MOV  R30,R10
	LDI  R26,LOW(_span)
	LDI  R27,HIGH(_span)
	CLR  R31
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETD1P
	POP  R26
	CLR  R27
	CLR  R24
	CLR  R25
	RCALL __CDF2
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_zero)
	SBCI R31,HIGH(-_zero)
	LD   R30,Z
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __ADDF12
	POP  R26
	POP  R27
	RCALL __CFD1
	ST   X,R30
	INC  R10
	RJMP _0x5D
_0x5E:
;     150     // finding the two minimum sensory readings.
;     151     x[0,0]=250;x[0,1]=250;x[1,0]=250;x[1,1]=250;   //x={0,0,0,0};     
	LDI  R30,LOW(250)
	STS  _x,R30
	__PUTB1MN _x,1
	__PUTB1MN _x,2
	__PUTB1MN _x,3
;     152     for (i=0;i<=5;i++)                    
	CLR  R10
_0x60:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRLO _0x61
;     153        if (sensor_state[i]<x[0,0])
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_state)
	SBCI R31,HIGH(-_sensor_state)
	LD   R30,Z
	MOV  R26,R30
	LDS  R30,_x
	CP   R26,R30
	BRSH _0x62
;     154        {
;     155            x[0,0]=sensor_state[i];
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_state)
	SBCI R31,HIGH(-_sensor_state)
	LD   R30,Z
	STS  _x,R30
;     156            x[0,1]=i;
	__PUTBMRN _x,1,10
;     157        }              
;     158     for (i=0;i<=5;i++)                    
_0x62:
	INC  R10
	RJMP _0x60
_0x61:
	CLR  R10
_0x64:
	LDI  R30,LOW(5)
	CP   R30,R10
	BRLO _0x65
;     159        if (i != x[0,1])
	__GETB1MN _x,1
	CP   R30,R10
	BREQ _0x66
;     160            if (sensor_state[i]<x[1,0])
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_state)
	SBCI R31,HIGH(-_sensor_state)
	LD   R30,Z
	PUSH R30
	__GETB1MN _x,2
	POP  R26
	CP   R26,R30
	BRSH _0x67
;     161                {
;     162                x[1,0]=sensor_state[i];
	MOV  R30,R10
	CLR  R31
	SUBI R30,LOW(-_sensor_state)
	SBCI R31,HIGH(-_sensor_state)
	LD   R30,Z
	__PUTB1MN _x,2
;     163                x[1,1]=i;
	__PUTBMRN _x,3,10
;     164                }              
;     165     e=(x[0,1]+x[1,1])*10;
_0x67:
_0x66:
	INC  R10
	RJMP _0x64
_0x65:
	__GETB1MN _x,1
	PUSH R30
	__GETB1MN _x,3
	POP  R26
	ADD  R26,R30
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R4,R30
;     166     e=e-50;
	MOV  R30,R4
	SUBI R30,LOW(50)
	MOV  R4,R30
;     167     //e=e+((x[0,0]-x[1,0])/20);
;     168 }
	RET
;     169 //-------------------CALCULATING THE CONTROLLER SIGNAL,u(t)-----------------
;     170 void PID()
;     171 {
_PID:
;     172    D=kd*(e-(P/kp));
	MOV  R30,R5
	LSR  R30
	MOV  R26,R30
	MOV  R30,R4
	SUB  R30,R26
	CLR  R6
;     173    P=kp*e;
	MOV  R30,R4
	LSL  R30
	MOV  R5,R30
;     174    I=I+(ki*e);
	MOV  R30,R4
	CLR  R30
	ADD  R7,R30
;     175    u=D+P+I;
	MOV  R30,R5
	ADD  R30,R6
	ADD  R30,R7
	CLR  R31
	__PUTW1R 8,9
;     176 }
	RET
;     177 //---------------------CALCULATING EACH MOTOR SPEED-------------------------
;     178 void PWM()
;     179 {
_PWM:
;     180    //TCCR1A=0xA1;
;     181    OCR1AL=speed-u;
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	SUB  R30,R8
	SBC  R31,R9
	OUT  0x2A,R30
;     182    OCR1BL=speed+u;
	__GETW1R 8,9
	SUBI R30,LOW(-100)
	SBCI R31,HIGH(-100)
	OUT  0x28,R30
;     183    //OCR1AL=speed+u-(D*something); 
;     184    //OCR1BL=speed-u-(D*something);
;     185    //this term is to reduce the speed on sharp turns
;     186    //delay_ms(1);
;     187    //TCCR1A=0;
;     188 }
	RET
;     189 void end_of_following()
;     190 {
_end_of_following:
;     191    while(1)
_0x6B:
;     192    {   
;     193        //turning both motors off
;     194        OCR1AL=0;
	CLR  R30
	OUT  0x2A,R30
;     195        OCR1BL=0;
	OUT  0x28,R30
;     196        ADCSRA=0;
	OUT  0x6,R30
;     197    }
	RJMP _0x6B
;     198 }   
	RET
_log:
	SBIW R28,4
	RCALL __SAVELOCR2
	__GETD2S 6
	RCALL __CPD02
	BRLT _0x6F
	__GETD1N 0xFF7FFFFF
	RJMP _0x7D
_0x6F:
	__GETD1S 6
	RCALL __PUTPARD1
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _frexp
	__PUTD1S 6
	__GETD2S 6
	__GETD1N 0x3F3504F3
	RCALL __CMPF12
	BRSH _0x70
	__GETD1S 6
	RCALL __ADDF12
	__PUTD1S 6
	__SUBWRN 16,17,1
_0x70:
	__GETD2S 6
	__GETD1N 0x3F800000
	RCALL __SWAPD12
	RCALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 6
	__GETD2N 0x3F800000
	RCALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	__PUTD1S 6
	__GETD2S 6
	RCALL __MULF12
	__PUTD1S 2
	__GETD2N 0x3F654226
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x4054114E
	RCALL __SWAPD12
	RCALL __SUBF12
	__GETD2S 6
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 2
	__GETD1N 0x3FD4114D
	RCALL __SWAPD12
	RCALL __SUBF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETW1R 16,17
	__GETD2N 0x3F317218
	RCALL __CWD1
	RCALL __CDF1
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
_0x7D:
	RCALL __LOADLOCR2
	ADIW R28,10
	RET
_exp:
	SBIW R28,8
	RCALL __SAVELOCR2
	__GETD2S 10
	__GETD1N 0xC2AEAC50
	RCALL __CMPF12
	BRSH _0x72
	__GETD1N 0x0
	RJMP _0x7C
_0x72:
	__GETD1S 10
	RCALL __CPD10
	BRNE _0x73
	__GETD1N 0x3F800000
	RJMP _0x7C
_0x73:
	__GETD2S 10
	__GETD1N 0x42B17218
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x74
	__GETD1N 0x7F7FFFFF
	RJMP _0x7C
_0x74:
	__GETD2S 10
	__GETD1N 0x3FB8AA3B
	RCALL __MULF12
	__PUTD1S 10
	RCALL __PUTPARD1
	RCALL _floor
	RCALL __CFD1
	__PUTW1R 16,17
	__GETW1R 16,17
	__GETD2S 10
	RCALL __CWD1
	RCALL __CDF1
	RCALL __SWAPD12
	RCALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3F000000
	RCALL __SWAPD12
	RCALL __SUBF12
	__PUTD1S 6
	__GETD2S 6
	RCALL __MULF12
	__PUTD1S 2
	__GETD2N 0x3D6C4C6D
	RCALL __MULF12
	__GETD2N 0x40E6E3A6
	RCALL __ADDF12
	__GETD2S 6
	RCALL __MULF12
	__PUTD1S 6
	__GETD1S 2
	__GETD2N 0x41A68D28
	RCALL __ADDF12
	__PUTD1S 2
	__GETD1S 6
	__GETD2S 2
	RCALL __ADDF12
	__GETD2N 0x3FB504F3
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 6
	__GETD1S 2
	RCALL __SUBF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	RCALL __PUTPARD1
	ST   -Y,R17
	ST   -Y,R16
	RCALL _ldexp
_0x7C:
	RCALL __LOADLOCR2
	ADIW R28,14
	RET
_pow:
	SBIW R28,4
	__GETD1S 8
	RCALL __CPD10
	BRNE _0x76
	__GETD1N 0x0
	RJMP _0x7B
_0x76:
	__GETD2S 8
	RCALL __CPD02
	BRGE _0x77
	__GETD1S 4
	RCALL __CPD10
	BRNE _0x78
	__GETD1N 0x3F800000
	RJMP _0x7B
_0x78:
	__GETD1S 8
	RCALL __PUTPARD1
	RCALL _log
	__GETD2S 4
	RCALL __MULF12
	RCALL __PUTPARD1
	RCALL _exp
	RJMP _0x7B
_0x77:
	__GETD1S 4
	MOVW R26,R28
	RCALL __CFD1
	RCALL __PUTDP1
	__GETD1S 0
	RCALL __CDF1
	MOVW R26,R30
	MOVW R24,R22
	__GETD1S 4
	RCALL __CPD12
	BREQ _0x79
	__GETD1N 0x0
	RJMP _0x7B
_0x79:
	__GETD1S 8
	RCALL __ANEGF1
	RCALL __PUTPARD1
	RCALL _log
	__GETD2S 4
	RCALL __MULF12
	RCALL __PUTPARD1
	RCALL _exp
	__PUTD1S 8
	LD   R30,Y
	ANDI R30,LOW(0x1)
	BRNE _0x7A
	__GETD1S 8
	RJMP _0x7B
_0x7A:
	__GETD1S 8
	RCALL __ANEGF1
_0x7B:
	ADIW R28,12
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

	rjmp __addfc

_ceil:
	rcall __ftrunc
	brne __ceil1
__ceil0:
	ret
__ceil1:
	brts __ceil0
	ldi  r25,0x3f

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CBD1:
	CLR  R31
	CLR  R22
	CLR  R23
	SBRS R30,7
	RET
	SER  R31
	SER  R22
	SER  R23
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__CBD2:
	CLR  R27
	CLR  R24
	CLR  R25
	SBRS R26,7
	RET
	SER  R27
	SER  R24
	SER  R25
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

_frexp:
	LD   R26,Y+
	LD   R27,Y+
	LD   R30,Y+
	LD   R31,Y+
	LD   R22,Y+
	LD   R23,Y+
	BST  R23,7
	LSL  R22
	ROL  R23
	CLR  R24
	SUBI R23,0x7E
	SBC  R24,R24
	ST   X+,R23
	ST   X,R24
	LDI  R23,0x7E
	LSR  R23
	ROR  R22
	BRTS __ANEGF1
	RET

_ldexp:
	LD   R26,Y+
	LD   R27,Y+
	LD   R30,Y+
	LD   R31,Y+
	LD   R22,Y+
	LD   R23,Y+
	BST  R23,7
	LSL  R22
	ROL  R23
	ADD  R23,R26
	LSR  R23
	ROR  R22
	BRTS __ANEGF1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

