//This program is geneerated by M.Mashaghi
//e-mail:m.mashaghi@gmail.com
//Date    : 2006/08/15
#include<mega8.h>
#include<delay.h> 
#include<math.h>
#define kp 2 
#define kd 0
#define ki 0
#define speed 100
#define ADC_CONFIGURATION 0b00100000  // Read the 8 most significant bits of the AD conversion result
void calibration();
void readlineposition();
void PID();
void PWM();
void end_of_following();
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input|ADC_CONFIGURATION;
ADCSRA|=0x40;// Start the AD conversion
while ((ADCSRA & 0x10)==0);// Wait for the AD conversion to complete
ADCSRA|=0x10; 
return ADCH;
}
char e,P,D,I;
int u;
unsigned char i,m,n; 
unsigned char sensor_white[6],sensor_black[6],sensor_state[6],zero[6],x[2,2];
float span[6];

main()
{
 DDRB=0xdf;
 PORTB=0;
 DDRC=0;
 PORTC=0;
 DDRD=0xff;
 PORTD=0;
 I=0;P=0;D=0; 
 // Timer/Counter 1 initialization
 // Clock source: System Clock
 // Clock value: 125.000 kHz
 // Mode: Normal top=FFFFh
 // OC1A output: Clear
 // OC1B output: Clear
 // Noise Canceler: Off
 // Input Capture on Falling Edge
 TCCR1A=0xA1;
 TCCR1B=0x01;
 TCNT1H=0;TCNT1L=0;
 OCR1AH=0;OCR1AL=0;
 OCR1BH=0;OCR1BL=0;
 // ADC initialization
 //ADC Clock frequency: 500.000 kHz
 // ADC Voltage Reference: AREF
 // ADC High Speed Mode: Off
 //ADC Auto Trigger Source: None
 ADMUX=ADC_CONFIGURATION;
 ADCSRA=0x80;
 SFIOR&=0xEF;
 ACSR=0x80;

 calibration();
 while(1)
 {
    readlineposition();
    PID();
    PWM();
    if(~PINB.5) end_of_following();
 } 
}

//----------------------------CALIBRATION----------------------------------
void calibration()
{  
    while (PINB.5)
    {
       PORTB.4=1;
       delay_ms(50);
       PORTB.4=0;
       delay_ms(50);
    }
    PORTB.4=0;
    while (PINB.5==0);
    delay_ms(1000);
 
    for (i=0;i<=5;i++)    
    {
       PORTD=ceil(pow(2,i));
       delay_us(50);
       m=read_adc(i); 
       PORTD=0;
       delay_us(50);
       n=read_adc(i); 
       sensor_white[i]=m-n;
    }
    
    while (PINB.5)
    {
       PORTB.4=1;
       delay_ms(50);
       PORTB.4=0;
       delay_ms(50);
    }
    PORTB.4=0;
    while (PINB.5==0);
    delay_ms(1000);

    for (i=0;i<=5;i++)    
    {
       PORTD=ceil(pow(2,i));
       delay_us(50);
       m=read_adc(i); 
       PORTD=0;
       delay_us(50);
       n=read_adc(i); 
       sensor_black[i]=m-n;
    } 
    //calculating ZERO and SPAN coeffecients.
    //these coeffecients assumed to calibrate each sensor.
    for (i=0;i<=5;i++)    
       span[i]=150/(sensor_white[i]-sensor_black[i]);
    for (i=0;i<=5;i++)    
       zero[i]=200-((sensor_white[i]*span[i])/(sensor_white[i]-sensor_black[i]));
    
    while (PINB.5)
    {
       PORTB.4=1;delay_ms(50);
       PORTB.4=0;delay_ms(50);
    }
    PORTB.4=0;
    while (PINB.5==0);
    delay_ms(1000); 
}
//------------------------READ CURRENT LINE POSITION------------------------
void readlineposition()
{
    for (i=0;i<=5;i++)
    {
       PORTD=ceil(pow(2,i));
       delay_us(50);
       m=read_adc(i); 
       PORTD=0;
       delay_us(50);
       n=read_adc(i); 
       sensor_state[i]=m-n;
       //sensor_state[i]=m;
    }
    for (i=0;i<=5;i++)   sensor_state[i]=(sensor_state[i]*span[i])+zero[i];
    // finding the two minimum sensory readings.
    x[0,0]=250;x[0,1]=250;x[1,0]=250;x[1,1]=250;   //x={0,0,0,0};     
    for (i=0;i<=5;i++)                    
       if (sensor_state[i]<x[0,0])
       {
           x[0,0]=sensor_state[i];
           x[0,1]=i;
       }              
    for (i=0;i<=5;i++)                    
       if (i != x[0,1])
           if (sensor_state[i]<x[1,0])
               {
               x[1,0]=sensor_state[i];
               x[1,1]=i;
               }              
    e=(x[0,1]+x[1,1])*10;
    e=e-50;
    //e=e+((x[0,0]-x[1,0])/20);
}
//-------------------CALCULATING THE CONTROLLER SIGNAL,u(t)-----------------
void PID()
{
   D=kd*(e-(P/kp));
   P=kp*e;
   I=I+(ki*e);
   u=D+P+I;
}
//---------------------CALCULATING EACH MOTOR SPEED-------------------------
void PWM()
{
   //TCCR1A=0xA1;
   OCR1AL=speed-u;
   OCR1BL=speed+u;
   //OCR1AL=speed+u-(D*something); 
   //OCR1BL=speed-u-(D*something);
   //this term is to reduce the speed on sharp turns
   //delay_ms(1);
   //TCCR1A=0;
}
void end_of_following()
{
   while(1)
   {   
       //turning both motors off
       OCR1AL=0;
       OCR1BL=0;
       ADCSRA=0;
   }
}   